package kieker.webgui.beans;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import org.primefaces.model.DefaultTreeNode;
import org.primefaces.model.TreeNode;

/**
 * This bean can be used to store and read the currently available plugins for
 * the current main project.
 *
 * @author Nils Christian Ehmke
 */
@ManagedBean
@RequestScoped
public class AvailablePluginsBean {

    public synchronized TreeNode getAvailablePluginsRoot() {
        TreeNode root = new DefaultTreeNode("Root", null);

        final TreeNode readerNode = new DefaultTreeNode("Reader", root);
        final TreeNode analysisPluginsNode = new DefaultTreeNode("AnalysisPlugins", root);

        TreeNode node00 = new DefaultTreeNode("FSReader", readerNode);
        TreeNode node01 = new DefaultTreeNode("JMXReader", readerNode);

        TreeNode node10 = new DefaultTreeNode("DummyRecordConsumer", analysisPluginsNode);
        TreeNode node11 = new DefaultTreeNode("SilentCountingRecordConsumer", analysisPluginsNode);
        TreeNode node12 = new DefaultTreeNode("TraceEquivalenceClassFilter", analysisPluginsNode);
        TreeNode node13 = new DefaultTreeNode("ExecutionRecordTransformationFilter", analysisPluginsNode);
        TreeNode node14 = new DefaultTreeNode("ResourceUtilizationPlugin", analysisPluginsNode);
        TreeNode node15 = new DefaultTreeNode("TraceReconstructionPlugin", analysisPluginsNode);
        TreeNode node16 = new DefaultTreeNode("CPUGraphPlugin", analysisPluginsNode);
        TreeNode node17 = new DefaultTreeNode("SequenceDiagramPlugin", analysisPluginsNode);
        TreeNode node18 = new DefaultTreeNode("DependencyGraphPlugin", analysisPluginsNode);
        TreeNode node19 = new DefaultTreeNode("PerformanceAnomalyPlugin", analysisPluginsNode);
        TreeNode node20 = new DefaultTreeNode("AnomalyGraphPlugin", analysisPluginsNode);
        return root;
    }
}
