package kieker.webgui.beans;

import java.util.ArrayList;
import java.util.List;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import kieker.analysis.model.analysisMetaModel.MIProject;
import kieker.analysis.model.analysisMetaModel.impl.MAnalysisMetaModelFactory;
import org.primefaces.model.DefaultTreeNode;
import org.primefaces.model.TreeNode;

/**
 * This bean can be used to handle all available projects within the program.
 *
 * @author Nils Christian Ehmke
 */
@ManagedBean
@ApplicationScoped
public class AvailableProjectsBean {

    private final List<MIProject> projects;
    private final MAnalysisMetaModelFactory factory;

    public AvailableProjectsBean() {
        projects = new ArrayList<MIProject>();
        factory = new MAnalysisMetaModelFactory();
    }

    public synchronized boolean addProject(final String projectName) {
        final MIProject project = factory.createProject();

        project.setName(projectName);

        return projects.add(project);
    }

    public synchronized TreeNode getProjectsRoot() {
       /* TreeNode root = new DefaultTreeNode("Root", null);

        for (final MIProject project : projects) {
            final TreeNode projectNode = new DefaultTreeNode("project", project, root);
            final TreeNode dependenciesNode = new DefaultTreeNode("dependencies", "Dependencies", projectNode);
            final TreeNode usedPluginsNode = new DefaultTreeNode("usedPlugins", "Used Plugins", projectNode);
        }*/
        
        TreeNode root = new DefaultTreeNode("Root", null);
        TreeNode node0 = new DefaultTreeNode("dependencies", "JPetStore Analysis", root);
        TreeNode node1 = new DefaultTreeNode("dependencies", "Bookstore Analysis", root);

        TreeNode node2432 = new DefaultTreeNode("dependencies", "Dependency", node0);
        TreeNode node2 = new DefaultTreeNode("dependencies", "Dependency", node1);
        TreeNode node3 = new DefaultTreeNode("dependencies", "Kieker.jar", node2);
        TreeNode node4 = new DefaultTreeNode("dependencies", "Used Plugins", node1);

        TreeNode node11 = new DefaultTreeNode("dependencies", "Reader", node4);
        TreeNode node12 = new DefaultTreeNode("dependencies", "Analysis Plugins", node4);

        TreeNode node5 = new DefaultTreeNode("dependencies", "FSReader", node11);
        TreeNode node6 = new DefaultTreeNode("dependencies", "PerformanceAnomalyPlugin", node12);
        TreeNode node7 = new DefaultTreeNode("dependencies", "TraceReconstructionPlugin", node12);
        TreeNode node8 = new DefaultTreeNode("dependencies", "AnomalyGraphPlugin", node12);
        TreeNode node9 = new DefaultTreeNode("dependencies", "SequenceDiagramPlugin", node12);
        TreeNode node10 = new DefaultTreeNode("dependencies", "DependencyGraphPlugin", node12);
   

        return root;
    }
}
